
GammaLib - Action #261

Feature # 226 (Closed): Parallelize maximum likelihood computation

Study possible options for parallelization

07/02/2012 12:05 PM - Knödlseder Jürgen

Status: Closed Start date: 06/16/2012

Priority: Normal Due date:  

Assigned To:  % Done: 100%

Category:  Estimated time: 35.00 hours

Target version: Stage Jean-Baptiste Cayrou   

Description

As a first step of the project we should study the possible options that exists for code parallelization.

We recall the requirements:

no code dependencies (use only native C++ features)

no limits due to Python Global Interpreter Lock (GIL)

support concurrent memory access

enabling / disabling during compile time

selection of number of cores during setting of environment variable

History

#1 - 07/02/2012 12:07 PM - Knödlseder Jürgen

- Description updated

- Estimated time set to 35.00

- Remaining (hours) set to 35.0

#2 - 07/02/2012 12:28 PM - Anonymous

- Status changed from New to In Progress

#3 - 07/02/2012 12:53 PM - Anonymous

Some information about Swig and threads:

http://stackoverflow.com/questions/2510696/allowing-threads-from-python-after-calling-a-blocking-i-o-code-in-a-python-exten

http://matt.eifelle.com/2007/11/23/enabling-thread-support-in-swig-and-python/

http://code.activestate.com/recipes/52294-use-modules-generated-with-swig-in-a-multi-thread-/

#4 - 07/05/2012 04:32 PM - Anonymous

- Status changed from In Progress to Resolved

#5 - 07/05/2012 04:59 PM - Anonymous

- % Done changed from 0 to 100

Finally, I will use the OpenMP API which allow multi-threading just with directive for compiler.

For instance the following directive will share the loop on several threads.

#pragma omp for
for(int i=0;i<n;i++)

{

...

}

It is easy to parallelize a code. When the option is disable the compiler does not care the pragma lignes and it works like for a mono thread code.

Many compilers implement the OpenMP API (with gcc, just add "-fopenmp" to active it).

Moreover it is possible to set the number of thread with an environment variable ( OMP_NUM_THREADS )

#6 - 07/10/2012 03:54 PM - Anonymous

- Status changed from Resolved to Closed

- Remaining (hours) changed from 35.0 to 0.0

#7 - 07/28/2012 12:53 AM - Knödlseder Jürgen

- Target version deleted (Stage Jean-Baptiste Cayrou)

#8 - 07/28/2012 12:53 AM - Knödlseder Jürgen

- Target version set to Stage Jean-Baptiste Cayrou
